
; Public Domain

; test install command: install; ldmem; ldmem uninstall
; test run command: ; .; .

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"
%include "isvariab.mac"

	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=_ELD_RELOC_VSTART
relocateddata:

	addsection HEADER, start=0

	istruc ELD_HEADERX
at eldhxHeader
		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
at eldhExtensionSize,	dw header_extension_end - $$
	iend
at eldhxDescriptionOffset,	dd description
header_extension_end:
	iend

description:		asciz "Dump lDebug memory use."


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "LDMEM"
	iend


	numdef ELD_BUG, 0
	numdef ELD_BUG_RELOC, _ELD_BUG
	numdef ELD_BUG_LINK, _ELD_BUG
	numdef ELD_BUG_LENGTH, _ELD_BUG


%rep _ELD_BUG_LINK
	dw relocateddata		; missing linkdatarelocation
%endrep

%rep _ELD_BUG_RELOC
	dw msg.ldmem			; missing internaldatarelocation
%endrep

%if _ELD_BUG_LENGTH && _ELD_CODE_VSTART
times 64 db 0
%endif

command:
	jmp strict short .entry
.chain:
	extcall cmd3_not_ext, required	; must NOT be extcallcall
	times 10 - ($ - command) nop
.entry:
	push si
	cmp al, '-'
	jne @F
	extcallcall skipcomma
@@:
	dec si

	mov dx, msg.ldmem
internaldatarelocation
	extcallcall isstring?
	je .ours
	pop si
	dec si
	lodsb
	jmp .chain

.ours:
	pop ax
	extcallcall skipcomma
	dec si
	mov dx, relocateddata
linkdatarelocation msg.uninstall
	extcallcall isstring?
	je uninstall
	call run
	extcallcall cmd3

uninstall:
	lodsb
	extcallcall chkeol

	call get_es_ext

	push es
	pop ds
	xor bx, bx		; = 0 (no prior, modify ext_command_handler)
	mov di, command		; di -> us
internalcoderelocation
	mov si, word [ss:relocateddata]
linkdatarelocation ext_command_handler
				; si -> first
	test si, si		; none installed ?
	jz .error		; error -->

.loop:
	cmp di, si		; found ?
	je .bx			; yes, use bx -->
	mov bx, si		; bx -> prior handler
	lodsw			; skip entrypoint jmp strict short
	lodsb			; get first byte of chainer
	cmp al, 0E9h		; expecting jmp near ?
	jne .error		; no, error -->
	lodsw			; get rel16 displacement
	add si, ax		; -> next handler
	jmp .loop

.bx:
	test bx, bx		; any prior ?
	jnz .bxnz		; yes -->
	scasw			; skip entrypoint jmp strict short
	cmp byte [di], 0E8h	; is it a call to cmd3_not_ext ?
	jne @F			; no -->
				; yes, reset ext_command_handler to zero
.setbx:
	mov word [ss:relocateddata], bx
linkdatarelocation ext_command_handler
	jmp .done

@@:
	cmp byte [di], 0E9h	; validate
	jne .error		; failure -->
	inc di			; -> rel16 displacement
	mov bx, word [di]	; get displacement
	scasw			; -> after jmp near
	add bx, di		; -> next handler
	jmp .setbx		; set ext_command_handler to next

.bxnz:
	mov si, bx		; -> prior handler with us as downlink
	xchg di, si		; si -> ours, di -> prior
	cmpsw			; skip entrypoint jmp strict short
	movsb			; copy 0E8h/0E9h
	lodsw			; ax = near rel16 displacement
	add ax, si		; add in our base (= absolute offset)
	sub ax, di
	dec ax
	dec ax			; subtract new base (= relative displacement)
	stosw			; store new rel16 displacement
	movsw			; jmp strict short
	movsw			; linkcall target
	movsb			; trailer
.done:
	clropt [code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as free
	mov dx, msg.uninstall_done
internaldatarelocation
@@:
	push ss
	pop ds
	extcallcall putsz
	extcallcall cmd3	; return

.error:
	mov dx, msg.uninstall_error
internaldatarelocation
	jmp @B


get_es_ext:
	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcallcall ispm
	jz @F
	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	retn


run:
	push ss
	pop es
	mov word [separatormessage], msg.empty
internaldatarelocation -4
internaldatarelocation
	lodsb
	extcallcall iseol?
	jne @F
	mov si, msg.all + 1
internaldatarelocation
@@:
	dec si			; -> keyword

	xor ax, ax
	push ax			; on stack = 0

.loopouter:			; si -> next keyword
	lodsb
	extcallcall iseol?
	jne @F
.continue:
	pop si			; get next string
	test si, si		; any ?
	jnz .loopouter		; yes -->
	retn			; done

@@:
	dec si			; -> keyword
	xchg si, cx
	mov si, nountable
internaldatarelocation
.loop:
	lodsb
	mov ah, 0
	add ax, si
	cmp ax, si
	je .notfound
	xchg dx, ax		; -> match string
	xchg si, cx		; si -> keyword
	extcallcall isstring?
	je .got
	xchg si, cx		; si -> table
	lodsb
	lodsw			; skip
	jmp .loop		; try to match next noun -->

.got:
	extcallcall skipcomma
	dec si			; -> next keyword
	push si			; stack next keyword
	xchg si, cx		; si -> table
	lodsb
	cmp al, 1
	lodsw			; ax -> next string or function
	je .sublist
.function:
	call .separator
	call ax			; call code
	 push ss
	 pop es
	 push ss
	 pop ds
	pop si			; restore -> next keyword
	jmp .loopouter		; continue noun loop -->

.sublist:
	xchg si, ax		; si -> sub list
	jmp .loopouter		; handle sub list --> (stack has continue offset)

.notfound:
	call .separator
	mov dx, msg.notfound.1
internaldatarelocation
	extcallcall putsz
	xchg si, cx		; si -> keyword
	mov dx, si		; dx -> start of keyword
@@:
	lodsb
	extcallcall iseol?	; EOL ?
	je @F
	cmp al, 32		; blank ?
	je @F
	cmp al, 9
	je @F
	cmp al, ','		; comma ?
	jne @B
		; We do not want to loop on trailing commas
		;  indefinitely, so handle this in a special
		;  way here. (Trailing comma after a valid
		;  name will emit the not found message with
		;  an empty name.)
	push si
	extcallcall skipwhite
	extcallcall iseol?	; EOL after comma ?
	jne .nottrailingcomma
	dec si
	pop ax			; -> after keyword + 1
	dec ax			; -> after keyword
	mov cx, ax		; -> after keyword
	jmp @FF

.nottrailingcomma:
	pop si
@@:
	dec si			; -> after keyword
	mov cx, si		; -> after keyword
@@:
	sub cx, dx		; cx = length of keyword
	extcallcall puts
	mov dx, msg.notfound.2
internaldatarelocation
	extcallcall putsz
	extcallcall skipcomma	; skip comma (except trailing comma)
	dec si			; -> next keyword
	jmp .loopouter

.separator:
	mov dx, msg.linebreak
internaldatarelocation
	xchg dx, word [separatormessage]
internaldatarelocation
	extcallcall putsz
	retn


display_mem:
	mov si, table
internaldatarelocation
	mov dx, table_sorted
internaldatarelocation

loopprepare:
	lodsw
	test ax, ax
	jz .done
	lodsw
	test ax, ax
	jnz @F
.segzero:
	add si, 4
	jmp .next

@@:
	xchg bx, ax
	mov ax, [bx]
	test ax, ax
	jz .segzero
	mov di, table_sorted + 4
internaldatarelocation
@@:
	cmp di, dx
	jae .insert_at_di_minus_4
	scasw
	jb .insert_at_di_minus_6
	add di, 6
	jmp @B

.insert_at_di_minus_4:
	scasw
.insert_at_di_minus_6:
	sub di, 6
.insert_at_di:
	mov cx, dx
	sub cx, di
	push si
	push di
	mov di, dx		; -> end
	add di, 8		; -> after destination
	mov dx, di		; update -> end
	std			; AMD erratum 109 workaround
	scasw			; -> last word destination
	lea si, [di - 8]	; -> last word source (dx - 2)
	shr cx, 1		; = amount of words
	jcxz @FF
	cmp cx, 20
	ja @FF
@@:
	movsw
	loop @B
@@:
	rep movsw		; move up all following entries
	cld
	pop di
	pop si
	sub si, 4
	movsw			; copy message offset
	movsw			; copy seg offset
	stosw			; store seg value
	lodsw			; skip this field
	movsw			; copy size offset
.next:
	jmp loopprepare

.done:
	xchg dx, di
	xor ax, ax
	stosw			; terminator

	mov bx, relocateddata
linkdatarelocation alloc_seg, -2, optional
	mov dx, bx
	test bx, bx
	jz @F
	mov dx, [bx]
@@:

	mov si, table_sorted
internaldatarelocation
loop:
	mov di, relocateddata
linkdatarelocation line_out
	lodsw
	test ax, ax
	jz .done
	push si
	push ax
	lodsw
	test dx, dx
	jz .nogap
	test ax, ax
	jz .nogap
	xchg bx, ax
	mov ax, [bx]
	cmp dx, ax
	jae .nogap
	call gap
.nogap:
	pop si
	extcallcall copy_single_counted_string
	pop si
	lodsw
	test ax, ax
	jnz @F
	add si, 4
	push si
	mov si, msg.none
internaldatarelocation
.next_string:
	extcallcall copy_single_counted_string
	xor dx, dx
	pop si
	jmp .next

@@:
	xchg bx, ax
	mov cx, relocateddata + 26
linkdatarelocation line_out
	sub cx, di
	jbe @F
	mov al, 32
	rep stosb
@@:
	mov ax, [bx]
	mov dx, ax
	extcallcall hexword
	push si
	mov si, msg.address.1
internaldatarelocation
	extcallcall copy_single_counted_string
	pop si
	lodsw
	lodsw
	test ax, ax
	jnz @F
	push si
	mov si, msg.nonesize
internaldatarelocation
	jmp .next_string

@@:
	push dx
	push si
	mov si, msg.size.1
internaldatarelocation
	extcallcall copy_single_counted_string
	xchg bx, ax
	mov ax, [bx]
	extcallcall hexword
	mov si, msg.size.2
internaldatarelocation
	extcallcall copy_single_counted_string
	xor dx, dx
	mov cx, 1
	mov bx, 9
	extcallcall disp_dxax_times_cx_width_bx_size.store
	pop si
	pop dx
	add ax, 15
	shr ax, 1
	shr ax, 1
	shr ax, 1
	shr ax, 1
	add dx, ax
.next:
	push dx
	extcallcall putsline_crlf
	pop dx
	jmp loop

.done:
loop_done:

	mov bx, relocateddata
linkdatarelocation alloc_seg, -2, optional
	test bx, bx
	jz .nogap
	mov ax, [bx]
	mov bx, relocateddata
linkdatarelocation alloc_size, -2, optional
	test bx, bx
	jz .nogap
	add ax, [bx]
	test dx, dx
	jz .nogap
	cmp dx, ax
	jae .nogap
	call gap
.nogap:


display_alloc:
	mov dx, msg.alloc
internaldatarelocation
	extcallcall putsz

	mov bx, relocateddata
linkdatarelocation alloc_seg, -2, optional
	test bx, bx
	jnz @F
	mov si, msg.none
.eol_string:
internaldatarelocation
	extcallcall copy_single_counted_string
	jmp .eol

@@:
	mov ax, [bx]
	extcallcall hexword
	mov si, msg.address.1
internaldatarelocation
	extcallcall copy_single_counted_string

	mov bx, relocateddata
linkdatarelocation alloc_size, -2, optional
	test bx, bx
	jnz @F
	mov si, msg.nonesize
internaldatarelocation
	jmp .eol_string

@@:
	mov ax, [bx]
	call parasize
.eol:
	extcallcall putsline_crlf
	retn


historysize:
	lframe none
	lenter
	mov byte [history_data_entry], 0
internaldatarelocation -3
	mov ax, relocateddata
linkdatarelocation historyformat, -2, optional
	test ax, ax
	jnz @F
	mov dx, msg.history_none
internaldatarelocation
.putsz_end:
	extcallcall putsz
	jmp .end

@@:
	mov dx, msg.history_data_entry
internaldatarelocation
	cmp ax, 2
	jb .in_data_entry
	mov dx, msg.history_separate
internaldatarelocation
	je .in_separate

	mov dx, msg.history_unknown
internaldatarelocation
	jmp .putsz_end

.in_data_entry:
	not byte [history_data_entry]
internaldatarelocation
.in_separate:
	extcallcall putsz
	mov bx, relocateddata
linkdatarelocation history.last, -2, optional
	mov dx, relocateddata
linkdatarelocation history.first, -2, optional
	test bx, bx
	jz @F
	test dx, dx
	jnz @FF

@@:
.missing:
	mov dx, msg.history_missing
internaldatarelocation
	jmp .putsz_end

@@:
	mov di, relocateddata
linkdatarelocation line_out
	mov si, msg.history.1
internaldatarelocation
	extcallcall copy_single_counted_string
	xchg dx, bx
	mov ax, [bx]
	xchg dx, bx
	sub ax, [bx]
	shr ax, 1
	extcallcall decword
	push ax
	mov si, msg.history.2
internaldatarelocation
	extcallcall copy_single_counted_string
	mov bx, [bx]
	rol byte [history_data_entry], 1
internaldatarelocation
	jc .not_seg
	push bx
	mov bx, relocateddata
linkdatarelocation history.segorsel, -2, optional
	test bx, bx
	jz .missing
	mov ds, word [bx]
	pop bx
.not_seg:
	mov ax, [bx]
	 push ss
	 pop ds
	pop cx
	add ax, cx
	add ax, cx
	push cx
	inc ax
	inc ax
	extcallcall decword
	push ax
	mov si, msg.history.3
internaldatarelocation
	extcallcall copy_single_counted_string
	mov bx, dx
	mov ax, [bx]
	rol byte [history_data_entry], 1
internaldatarelocation
	jnc .not_entry
	push bx
	mov bx, relocateddata
linkdatarelocation historybuffer, -2, optional
	test bx, bx
	jz .missing
	sub ax, bx
	pop bx
.not_entry:
	inc ax
	inc ax
	extcallcall decword
	pop ax
	pop dx
	test dx, dx
	jnz @F

	mov si, msg.history.average.none
internaldatarelocation
	jmp .string_end

@@:
	mov si, msg.history.average.1
internaldatarelocation
	extcallcall copy_single_counted_string

	xor cx, cx
	xchg cx, dx
	div cx
	test dx, dx
	jz @F
	inc ax
@@:
	extcallcall decword
	mov si, msg.history.average.2
internaldatarelocation
.string_end:
	extcallcall copy_single_counted_string
	extcallcall putsline_crlf
.end:
	lleave , forcerestoresp
	retn


stacksize:
	mov di, relocateddata
linkdatarelocation line_out
	mov bx, relocateddata
linkdatarelocation stack, -2, optional
	mov dx, relocateddata
linkdatarelocation stack_end, -2, optional
	test bx, bx
	jz @F
	test dx, dx
	jnz @FF
@@:
	mov si, msg.stack.none
internaldatarelocation
	jmp .string_end

@@:
	mov si, msg.stack.1
internaldatarelocation
	extcallcall copy_single_counted_string
	mov ax, dx
	sub ax, bx
	extcallcall decword
	mov si, msg.stack.2
internaldatarelocation
	extcallcall copy_single_counted_string
	mov al, [bx]
	extcallcall hexbyte
	mov si, msg.stack.3
internaldatarelocation
	extcallcall copy_single_counted_string
	xchg di, bx
	mov cx, -1
	repe scasb
	not cx
	dec cx
	xchg ax, cx
	xchg di, bx
	extcallcall decword
	mov si, msg.stack.4
internaldatarelocation

.string_end:
	extcallcall copy_single_counted_string
	extcallcall putsline
	retn


display_eld_memory:
	mov dx, msg.eld.1
internaldatarelocation
	extcallcall putsz

	xor ax, ax
.loop:
	mov di, relocateddata
linkdatarelocation line_out
	cmp word [relocateddata], ax
linkdatarelocation extseg_used
	ja @F

	xor bp, bp
	mov dx, word [relocateddata]
linkdatarelocation extseg_size
	sub dx, ax
	xor bx, bx
	xor cx, cx
.free:
	 push ss
	 pop ds
	push cx
	mov si, msg.eld.free
internaldatarelocation
	extcallcall copy_single_counted_string
	pop cx
	jmp .have

@@:
	mov bx, relocateddata
linkdatarelocation extdssel, -2, optional
	extcallcall ispm
	jz @F
	mov bx, relocateddata
linkdatarelocation extseg, -2, optional
@@:
	test bx, bx
	jnz @F
.error:
	mov dx, msg.eld.error
internaldatarelocation
	extcallcall putsz
	jmp .end

@@:
	mov es, word [bx]
	mov bx, ax
	cmp word [es:bx + eldiStartCode], ax
	jne .error
	mov dx, ax
	add dx, ELD_INSTANCE_size
	jc .error
	cmp word [es:bx + eldiEndCode], dx
	jb .error
	mov dx, word [relocateddata]
linkdatarelocation extseg_used
	cmp word [es:bx + eldiEndCode], dx
	ja .error
	je @F
	sub dx, ELD_INSTANCE_size
	jc .error
	cmp word [es:bx + eldiEndCode], dx
	ja .error
@@:
	mov dx, word [es:bx + eldiEndCode]
	mov bp, dx
	sub dx, ax
	jc .error
	push word [es:bx + eldiStartData]
	push bx
	mov bx, word [es:bx + eldiEndData]
	pop si
	testopt [es:si + eldiFlags], eldifResident
	lea si, [si + eldiIdentifier]
	push es
	pop ds
	 push ss
	 pop es
	pop cx
	jz .free
	push cx
	push ax
	mov al, '"'
	stosb
	mov cx, 4
	rep movsw
	stosb
	pop ax
	 push ss
	 pop ds
	pop cx
.have:
	mov si, msg.eld.2
internaldatarelocation
	push bx
	call display_eld_size
	pop bx

	mov ax, bx
	sub ax, cx
	jz .next
	xchg dx, ax
	mov ax, cx
	mov si, msg.eld.5
internaldatarelocation
	call display_eld_size

.next:
	extcallcall putsline_crlf
	test bp, bp
	mov ax, bp
	jnz .loop
.end:

	mov di, relocateddata
linkdatarelocation line_out
	mov ax, word [relocateddata]
linkdatarelocation extdata_used
	mov dx, word [relocateddata]
linkdatarelocation extdata_size
	sub dx, ax
	jz @F
	add ax, [relocateddata]
linkdatarelocation extdata
	mov si, msg.eld.6
internaldatarelocation
	call display_eld_size
	extcallcall putsline_crlf
@@:
	retn


display_eld_variables:
	mov di, relocateddata
linkdatarelocation line_out

	mov si, msg.var.format
internaldatarelocation
	extcallcall copy_single_counted_string

	mov ax, relocateddata
linkdatarelocation ext_var_format
	cmp ax, 1
	je .known

.unknown:
	mov di, msg.varunknown.format
internaldatarelocation
	extcallcall hexword

	mov dx, msg.varunknown
internaldatarelocation
	extcallcall putsz
	jmp .end

.known:
	extcallcall hexword

	mov si, msg.var.size
internaldatarelocation
	extcallcall copy_single_counted_string

	mov ax, relocateddata
linkdatarelocation ext_var_size

	extcallcall hexword
	xchg dx, ax

	mov si, msg.var.amount
internaldatarelocation
	extcallcall copy_single_counted_string

	xor bx, bx
	mov cx, relocateddata
linkdatarelocation ext_var_amount
	push cx
	jcxz .donecount

	push di
	mov di, relocateddata
linkdatarelocation ext_var
	mov si, relocateddata
linkdatarelocation isvariable_morebyte_nameheaders.ext
.loopcount:
	cmp word [di], 0
	je .nextcount
	inc bx
.nextcount:
	add di, dx
	lodsw
	loop .loopcount
	pop di
.donecount:

	xchg ax, bx
	extcallcall decword

	mov si, msg.var.amountbetween
internaldatarelocation
	extcallcall copy_single_counted_string

	pop ax
	extcallcall decword
	push ax

	mov si, msg.var.amountafter
internaldatarelocation
	extcallcall copy_single_counted_string
	push dx
	extcallcall putsline_crlf
	pop dx
	pop cx

	mov bx, relocateddata
linkdatarelocation ext_var
	mov si, relocateddata
linkdatarelocation isvariable_morebyte_nameheaders.ext

	jcxz .donelist
.looplist:
	cmp word [bx], 0
	je .nextlist
	push cx
	push si

	mov di, relocateddata
linkdatarelocation line_out

	mov si, msg.var.list.flags
internaldatarelocation
	extcallcall copy_single_counted_string

	mov ax, word [bx + ivFlags]
	extcallcall hexword

	mov si, msg.var.list.array
internaldatarelocation
	extcallcall copy_single_counted_string

	mov al, byte [bx + ivArrayLast]
	extcallcall hexbyte

	mov al, byte [bx + ivArrayBetween]
	test al, al
	jz @F

	mov si, msg.var.list.between
internaldatarelocation
	extcallcall copy_single_counted_string

	extcallcall hexbyte
@@:

	mov si, msg.var.list.name
internaldatarelocation
	extcallcall copy_single_counted_string

	pop si
	movsw
	push si

	mov si, word [bx + ivName]
	mov cx, word [bx + ivFlags]
	and cx, ivfNameLengthMask
	rep movsb

	push bx
	push dx

	mov ax, word [bx + ivAddress]
	mov si, msg.var.list.entry
internaldatarelocation
	call display_entry_and_instance

	extcallcall putsline_crlf
	pop dx
	pop bx

	pop si
	pop cx
	db __TEST_IMM8		; skip lodsw
.nextlist:
	lodsw
	add bx, dx
	loop .looplist
.donelist:

.end:
	retn


display_command_handler:
	mov bx, handlertable.command
internaldatarelocation
	jmp @F

display_amis_handler:
	mov bx, handlertable.amis
internaldatarelocation
	jmp @F

display_asm_handler:
	mov bx, handlertable.asm
internaldatarelocation
	jmp @F

display_puts_handler:
	mov bx, handlertable.puts
internaldatarelocation
@@:

display_handlers:
	houdini
	lframe
	lenter
	 push bx
	lvar word, table
	jmp @F

.next_table:
	mov dx, msg.handler.init.pre
internaldatarelocation
	extcallcall putsz
@@:
	mov dx, word [bx + htMessage]
	extcallcall putsz
	mov dx, msg.handler.init.post
internaldatarelocation
	extcallcall putsz

	mov dx, word [bx + htMessage]
	mov bx, word [bx + htHandler]
	mov bx, [bx]
	test bx, bx
	jnz @F
	push dx
	mov dx, msg.handler.none.pre
internaldatarelocation
	extcallcall putsz
	pop dx
	extcallcall putsz
	mov dx, msg.handler.none.post
internaldatarelocation
.putsz_end:
	extcallcall putsz
	jmp .end

@@:
.loop:
	push ss
	pop es
	push bx
	mov di, relocateddata
linkdatarelocation line_out
	xchg ax, bx
	mov si, msg.commandhandler.entry
internaldatarelocation
	call display_entry_and_instance
	extcallcall putsline_crlf
	pop bx
	call get_es_ext
	houdini
	mov si, word [bp + ?table]
	testopt [si + htIsAMIS], 1
	jz .notamis
	cmp word [es:bx], 03EBh
	jne .error
	cmp byte [es:bx + 2], 0E9h
	je .next
	cmp byte [es:bx + 2], 0CBh	; retf
	jne .error
	jmp .end

.notamis:
	cmp word [es:bx], 08EBh
	jne .error
	cmp byte [es:bx + 2], 0E9h
	jne @F
.next:
	add bx, word [es:bx + 2 + 1]
	add bx, 2 + 3
	jmp .loop

@@:
%if 1
	mov si, word [si + htTemplate]	; cs:si -> template
	mov cx, template_size
	sub sp, fromwords(words(template_size))
	push cs
	pop ds				; ds:si -> template
	mov di, sp			; ss:di -> stack
	push es
	 push ss
	 pop es				; es:di
	 push cx
	rep movsb
	 pop cx				; restore template length
	pop es				; => ELD instance
	push ss
	pop ds				; reset ds
	mov si, sp			; ds:si -> template on stack
	mov ax, [si + 1]
	mov di, word [bp + ?table]
	add ax, word [di + htTemplate]	; change to (biased) absolute offset
	lea di, [bx + 2]		; es:di -> downlink
	sub ax, di			; change to rel16 displacement
	mov word [si + 1], ax		; enter into template
	lea ax, [si + fromwords(words(template_size))]
					; -> prior stack
	rep cmpsb			; does it match expected downlink ?
	mov sp, ax			; reset stack
%else
	cmp byte [es:bx + 2], 0E8h
	jne .error
	mov ax, word [si + htReturn]
	cmp word [es:bx + 2 + 1 + 4], ax
%endif
	je .end
.error:
	push ss
	pop es
	mov bx, word [bp + ?table]
	mov dx, msg.handler.error.pre
internaldatarelocation
	extcallcall putsz
	mov dx, word [bx + htMessage]
	extcallcall putsz
	mov dx, msg.handler.error.post
internaldatarelocation
	jmp .putsz_end

.end:
	push ss
	pop es
	mov bx, word [bp + ?table]
	add bx, HANDLERTABLE_size
	mov word [bp + ?table], bx
	cmp word [bx], 0
	jne .next_table

	lleave
emptyfunction:
	retn


template_commandhandler:
template:
	extcall cmd3_not_ext, required	; must NOT be extcallcall
	endarea template
template_preprocesshandler:
	extcall cmd3_preprocessed, required	; must NOT be extcallcall
template_aabeforehandler:
	extcall aa_before_getline, required	; must NOT be extcallcall
template_aaafterhandler:
	extcall aa_after_getline, required	; must NOT be extcallcall
template_putshandler:
	extcall puts_ext_done, required		; must NOT be extcallcall
template_putscohandler:
	extcall puts_copyoutput_ext_done, required
				; must NOT be extcallcall


display_entry_and_instance:
	extcallcall copy_single_counted_string
	extcallcall hexword

	xchg dx, ax

	call get_es_ext
	xor si, si
	xor bx, bx
.loop:
	cmp si, word [relocateddata]
linkdatarelocation extseg_used
	jae .notfound
	cmp si, [es:si + eldiStartCode]
	jne .error
	lea bx, [si + ELD_INSTANCE_size]
	cmp bx, word [es:si + eldiEndCode]
	ja .error
	mov bx, word [es:si + eldiEndCode]
	cmp bx, dx
	je .error
	ja .found
.next:
	mov si, bx
	jmp .loop

.found:
	push es				; stack => ext seg
	xchg ax, si			; ax -> instance
	 push ss
	 pop es
	mov si, msg.instance.1
internaldatarelocation
	extcallcall copy_single_counted_string
	extcallcall hexword		; write offset -> instance

	mov si, msg.instance.2
internaldatarelocation
	extcallcall copy_single_counted_string

	xchg si, ax			; si -> instance
	lea si, [si + eldiIdentifier]	; si -> id
	pop ds				; => ext seg
	mov cl, 4			; cx = 4
	rep movsw			; copy id

	push ss
	pop ds

	mov si, msg.instance.3
internaldatarelocation
@@:
	push ss
	pop es
	extcallcall copy_single_counted_string
	retn

.notfound:
	mov si, msg.instance.notfound
internaldatarelocation
	jmp @B

.error:
	mov si, msg.instance.error
internaldatarelocation
	jmp @B


		; INP:	si -> first string
		;	ax = start
		;	dx = length
display_eld_size:
	push cx
	extcallcall copy_single_counted_string
	call hexword
	mov si, msg.eld.3
internaldatarelocation
	extcallcall copy_single_counted_string
	add ax, dx
	call hexword
	mov si, msg.eld.4
internaldatarelocation
	extcallcall copy_single_counted_string
	mov ax, dx
	call hexword
	mov si, msg.size.2
internaldatarelocation
	extcallcall copy_single_counted_string
	xor dx, dx
	mov cx, 1
	mov bx, 9
	extcallcall disp_dxax_times_cx_width_bx_size.store
	pop cx
	retn


parasize:
	mov si, msg.size.1
internaldatarelocation
	extcallcall copy_single_counted_string
	mov cl, 4
	push ax
	mov dx, ax
	rol ax, cl
	test al, 15
	jz @F
	dec di
	extcallcall hexnyb
@@:
	xchg ax, dx
	shl ax, cl
	extcallcall hexword
	mov si, msg.size.2
internaldatarelocation
	extcallcall copy_single_counted_string
	pop ax
	xor dx, dx
	mov cx, 16
	mov bx, 9
	extcallcall disp_dxax_times_cx_width_bx_size.store
	retn


		; INP:	dx => end of prior
		;	ax => start of next
gap:
	push dx
	neg dx
	add dx, ax
	mov si, msg.gap
internaldatarelocation
	extcallcall copy_single_counted_string
	pop ax
	extcallcall hexword
	mov si, msg.address.1
internaldatarelocation
	extcallcall copy_single_counted_string
	xchg ax, dx
	call parasize
	extcallcall putsline_crlf
	mov di, relocateddata
linkdatarelocation line_out
	retn


	eldcall_dump_callcall ELDCALL_CALLCALL_LIST

endinstalled equ ($ + CODEFIXUP + 15) & ~15


start:
	mov bx, es
	 push ss
	 pop es
	call skipcomma
	dec si
	mov dx, relocateddata
linkdatarelocation msg.install
	call isstring?
	je install
	call run
	call uninstall_oneshot
	xor ax, ax
	retf


uninstall_oneshot:
	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


install:
	lodsb
	extcall chkeol

	houdini
	mov es, bx		; => ext seg (writable)
	mov ax, endresident - endinstalled
	sub word [es:code + eldiEndCode], ax
internalcoderelocation		; adjust size
	sub word [relocateddata], ax
linkdatarelocation extseg_used	; adjust size
	mov bx, word [relocateddata]
linkdatarelocation ext_command_handler
				; -> prior
	mov di, command		; -> our handler
internalcoderelocation
	test bx, bx		; installing as first ?
	jz .only_first		; yes, simple --> (leave as extcall cmd3_not_ext)
	scasw			; skip entrypoint jmp strict short
	mov al, 0E9h		; = jmp near opcode
	stosb			; store
	xchg ax, bx		; ax -> next handler
	sub ax, di
	dec ax
	dec ax			; ax = ax - (di + 2)
	stosw			; store our downlink as rel16 displacement

.only_first:
	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as resident
	mov word [relocateddata], command
linkdatarelocation ext_command_handler, -4
internalcoderelocation		; -> our entrypoint

	testopt [relocateddata], 4
linkdatarelocation options7, -3
	jnz @F
	mov dx, msg.installed
internaldatarelocation
	call putsz
@@:
	xor ax, ax
	retf


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:

%rep _ELD_BUG
	dw msg.ldmem			; missing internaldatarelocation
%endrep

	align 8, db 0
table:
.:
	dw msg.entryseg
internaldatarelocation
	dw relocateddata
linkdatarelocation pspdbg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation entryseg_size, -2, optional

	dw msg.messageseg
internaldatarelocation
	dw relocateddata
linkdatarelocation messageseg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation messageseg_size, -2, optional

	dw msg.auxbuffseg
internaldatarelocation
	dw relocateddata
linkdatarelocation auxbuff_segment, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation auxbuff_current_size, -2, optional

	dw msg.codeseg
internaldatarelocation
	dw relocateddata
linkdatarelocation code_seg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation code_size, -2, optional

	dw msg.code2seg
internaldatarelocation
	dw relocateddata
linkdatarelocation code2_seg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation code2_size, -2, optional

	dw msg.historyseg
internaldatarelocation
	dw relocateddata
linkdatarelocation history_segment, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation historyseg_size, -2, optional

	dw msg.extseg
internaldatarelocation
	dw relocateddata
linkdatarelocation extseg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation extseg_size, -2, optional

	dw msg.envseg
internaldatarelocation
	dw relocateddata
linkdatarelocation envseg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation env_size, -2, optional
.end:
.amount equ (.end - .) / 8

	dw 0

	struc HANDLERTABLE
htMessage:		resw 1
htHandler:		resw 1
htTemplate:		resw 1
htReturn:		resw 1
htIsAMIS:		resw 1
	endstruc

	align 2, db 0
handlertable:
.command:
	istruc HANDLERTABLE
at htMessage,		dw msg.commandhandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_command_handler
at htTemplate,		dw template_commandhandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation cmd3_not_ext
	iend
	istruc HANDLERTABLE
at htMessage,		dw msg.preprocesshandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_preprocess_handler
at htTemplate,		dw template_preprocesshandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation cmd3_preprocessed
	iend
	dw 0

.amis:
	istruc HANDLERTABLE
at htMessage,		dw msg.amishandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_amis_handler
at htTemplate,		dw 0
at htReturn,		dw 0
at htIsAMIS,		dw 1
	iend
	dw 0

.asm:
	istruc HANDLERTABLE
at htMessage,		dw msg.aabeforehandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_aa_before_getline_handler
at htTemplate,		dw template_aabeforehandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation aa_before_getline
	iend
	istruc HANDLERTABLE
at htMessage,		dw msg.aaafterhandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_aa_after_getline_handler
at htTemplate,		dw template_aaafterhandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation aa_after_getline
	iend
	dw 0

.puts:
	istruc HANDLERTABLE
at htMessage,		dw msg.putshandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_puts_handler
at htTemplate,		dw template_putshandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation puts_ext_done
	iend
	istruc HANDLERTABLE
at htMessage,		dw msg.putscohandler
internaldatarelocation
at htHandler,		dw relocateddata
linkdatarelocation ext_puts_copyoutput_handler
at htTemplate,		dw template_putscohandler
internalcoderelocation
at htReturn,		dw relocateddata
linkdatarelocation puts_copyoutput_ext_done
	iend
	dw 0

	align 2, db 0
nountable:
	db msg.all - $ - 1
	db 1
	dw msg.all_replace
internaldatarelocation
	db msg.eldall - $ - 1
	db 1
	dw msg.eldall_replace
internaldatarelocation
	db msg.eldhandlers - $ - 1
	db 1
	dw msg.eldhandlers_replace
internaldatarelocation
	db msg.mem - $ - 1
	db 0
	dw display_mem
internalcoderelocation
	db msg.history - $ - 1
	db 0
	dw historysize
internalcoderelocation
	db msg.stack - $ - 1
	db 0
	dw stacksize
internalcoderelocation
	db msg.eld - $ - 1
	db 0
	dw display_eld_memory
internalcoderelocation
	db msg.eldvar - $ - 1
	db 0
	dw display_eld_variables
internalcoderelocation
	db msg.commandhandler_noun - $ - 1
	db 0
	dw display_command_handler
internalcoderelocation
	db msg.amishandler_noun - $ - 1
	db 0
	dw display_amis_handler
internalcoderelocation
	db msg.asmhandler - $ - 1
	db 0
	dw display_asm_handler
internalcoderelocation
	db msg.putshandler_noun - $ - 1
	db 0
	dw display_puts_handler
internalcoderelocation
	dw 0

history_data_entry:
	db 0

msg:
.all:		asciz "ALL"
.mem:		asciz "MEM"
.history:	asciz "HISTORY"
.stack:		asciz "STACK"
.eldall:	asciz "ELDALL"
.eld:		asciz "ELD"
.eldvar:	asciz "ELDVAR"
.eldhandlers:	asciz "ELDHANDLERS"
.commandhandler_noun:	asciz "COMMANDHANDLER"
.amishandler_noun:	asciz "AMISHANDLER"
.asmhandler:		asciz "ASMHANDLER"
.putshandler_noun:	asciz "PUTSHANDLER"
.all_replace:		asciz "MEM HISTORY STACK ELDALL"
.eldall_replace:	asciz "ELD ELDVAR ELDHANDLERS"
.eldhandlers_replace:	asciz "COMMANDHANDLER AMISHANDLER ASMHANDLER PUTSHANDLER"
.notfound.1:		asciz 'Noun "'
.notfound.2:		asciz '" not found!',13,10
.ldmem:			asciz "LDMEM"
.uninstall_done:	asciz "LDMEM uninstalled. (Don't forget to use reclaim.eld)",13,10
.uninstall_error:	asciz "LDMEM unable to uninstall!",13,10
.entryseg:	counted "Entry segment: "
.messageseg:	counted "Message segment: "
.codeseg:	counted "First code segment: "
.code2seg:	counted "Second code segment: "
.auxbuffseg:	counted "Auxiliary buffer segment: "
.historyseg:	counted "History segment: "
.extseg:	counted "ELD code segment: "
.envseg:	counted "Environment segment: "
.none:		counted "None (Segment data not available.)"
.nonesize:	counted "Size data not available."
.address.1:	counted "  "
.size.1:	counted "Size:  "
.size.2:	counted "  "
.alloc:		fill 26, 32, db "Total allocation: "
		asciz
.gap:		db .gap.end - ($ + 1)
		fill 26, 32, db "Gap: "
.gap.end:
.history_none:		asciz "No history format link found.",13,10
.history_data_entry:	asciz "History in data entry section.",13,10
.history_separate:	asciz "History in a separate segment.",13,10
.history_unknown:	asciz "Unknown history format.",13,10
.history_missing:	asciz "History last or first displacement or segment missing.",13,10
.history.1:		counted "History entries: "
.history.2:		counted 13,10,"History bytes: "
.history.3:		counted " used / "
.history.average.1:	counted " total",13,10,"Average history entry size is <= "
.history.average.2:	counted " bytes."
.history.average.none:	counted " total",13,10,"Cannot calculate average, no history entries."
.stack.none:		counted "No stack link found.",13,10
.stack.1:		counted "Stack size: "
.stack.2:		counted " bytes",13,10,"Heuristic match byte: "
.stack.3:		counted "h",13,10,"Heuristic unused stack: "
.stack.4:		counted " bytes",13,10
.eld.1:			asciz "Loaded ELDs:",13,10
.eld.error:		asciz "Error during ELD enumeration.",13,10
.eld.free:		counted "Free space"
.eld.2:			counted ", code start "
.eld.3:			counted ", stop "
.eld.4:			counted ", size "
.eld.5:			db .eld.5.end - ($ + 1)
			db 13,10
			times 8 + 2 + 2 db 32
			db "Data start "
.eld.5.end:
.eld.6:			counted "Free space, data start "
.var.format:		counted "Ext variables format="
.var.size:		counted "h, structure size="
.var.amount:		counted "h",13,10,"Amount ext variables: "
.var.amountbetween:	counted " used / "
.var.amountafter:	counted " total"
.varunknown:		db 13,10,"Unknown ext variables format="
.varunknown.format:	db "----h"
.linebreak:		db 13,10
.empty:			asciz
.var.list.flags:	counted "Flags="
.var.list.array:	counted "h array="
.var.list.between:	counted "h between="
.var.list.name:		counted "h name=",'"'
.var.list.entry:	counted '"',13,10," Entry="
.instance.1:		counted "h, instance="
.instance.2:		counted "h, identifier=",'"'
.instance.3:		counted '"'
.instance.notfound:	counted "h. Instance not found!"
.instance.error:	counted "h. Instance error!"
.commandhandler.entry:	counted " Entry="
.handler.init.pre:	asciz 13,10
.handler.init.post:	asciz " handlers:",13,10
.handler.none.pre:	asciz " Entry=0000h - No "
.handler.none.post:	asciz " handler installed.",13,10
.handler.error.pre:	asciz " "
.handler.error.post:	asciz " handler error!",13,10
.commandhandler:	asciz "Command"
.preprocesshandler:	asciz "Preprocess"
.amishandler:		asciz "AMIS"
.aabeforehandler:	asciz "Assembler before"
.aaafterhandler:	asciz "Assembler after"
.putshandler:		asciz "Multi-purpose puts"
.putscohandler:		asciz "COPYOUTPUT puts"

uinit_data: equ $
.installed:		asciz "LDMEM installed.",13,10

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data
	alignb 2
separatormessage:
	resw 1

	alignb 8
table_sorted:
	resb 8 * table.amount + 2

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
